'use strict';

var path = require('path');

module.exports = function webpackExtra (config, appPath) {
  var appPackage = require(path.join(appPath, 'package.json'));
  var appHasOwnProperty = function (key) {
    return Object.hasOwnProperty.bind(appPackage, key)();
  }

  config.module.rules = config.module.rules.map(function (loader) {
    if (
      loader.loader
      && loader.loader.indexOf('babel-loader') > -1
      && appHasOwnProperty('extraBabelPlugins')
    ) {
      loader.options.plugins = (loader.options.plugins || []).concat(appPackage.extraBabelPlugins);
    }

    return loader;
  })

  return config;
}
